//+------------------------------------------------------------------+
//| This MQL is generated by Expert Advisor Builder                  |
//|                http://sufx.core.t3-ism.net/ExpertAdvisorBuilder/ |
//|                                                                  |
//|  In no event will author be liable for any damages whatsoever.   |
//|                      Use at your own risk.                       |
//|                                                                  |
//+------------------- DO NOT REMOVE THIS HEADER --------------------+

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

#define FolderName_Screenshots   "Screenshots"
#define ScreenshotSizeX          1024
#define ScreenshotSizeY          768
#define ScreenshotStartBar       -1
#define ScreenshotChartScale     -1
#define ScreenshotChartMode      -1

extern string  __General         = "General settings";
extern int     BullUpCount       =   5;
extern int     BullDnCount       =  20;
extern int     BearDnCount       =   5;
extern int     BearUpCount       =  20;
extern bool    CreateScreenshots = true;

extern string  ___PAL            = "PAL settings";
extern string PALTimeFrame       = "Current time frame";
extern int    PALShowValue       =  1;
extern int    PALType            =  0;
extern double PALemaPeriod       =  1;
extern int    PALAreaBars        =  1;
extern double PALSmoothLength    =  1;
extern double PALSmoothPhase     =  0;
extern bool   PALSmoothDouble    = false;
extern bool   PALInterpolate     = true;
extern bool   PALShowTrigger    =  true;

extern string  ___Area            = "Area settings";
extern string AreaTimeFrame       = "Current time frame";
extern int    AreaShowValue       =  3;
extern int    AreaType            =  0;
extern double AreaemaPeriod       =  1;
extern int    AreaAreaBars        =  3;
extern double AreaSmoothLength    =  1;
extern double AreaSmoothPhase     =  0;
extern bool   AreaSmoothDouble    = false;
extern bool   AreaInterpolate     = true;
extern bool   AreaShowTrigger    =  true;

extern int MagicNumber = 1980;
extern bool SignalMail = False;
extern bool EachTickMode = true;
extern double Lots = 0.1;
extern int Slippage = 3;
extern bool UseStopLoss = True;
extern int StopLoss = 300;
extern bool UseTakeProfit = True;
extern int TakeProfit = 100;
extern bool UseTrailingStop = false;
extern int TrailingStop = 600;


static double pal[], area[];
static double palslope;
static bool   ActionPoint;
static bool    EndOfTrade;
static datetime lastTime=0;
static   bool BuyActive,SellActive;
static int TimeCount, TradeCount;
static   bool WasTrade;
static   string path_screenshots;


int BarCount;
int Current;
bool TickCheck = False;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;
   TimeCount = Bars;
   TradeCount = 0;


   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   int j,r;
   double StopLossLevel, TakeProfitLevel;

   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;

   //+------------------------------------------------------------------+
   //| Variable Begin                                                   |
   //+------------------------------------------------------------------+

   int NbrBars = MathMax(MathMax(MathMax(BullUpCount,BullDnCount),BearDnCount),BearUpCount);
   if (ArrayRange(pal,0)!=NbrBars) ArrayResize(pal,NbrBars);
   if (ArrayRange(area,0)!=NbrBars) ArrayResize(area,NbrBars);
   for (j=NbrBars, r=0; j >= 0; j--,r++)
   {
      pal[r] = iCustom(NULL, 0, "PalND_v1.55",PALTimeFrame,PALShowValue,PALType,PALemaPeriod,PALAreaBars,PALSmoothLength,PALSmoothPhase,PALSmoothDouble,PALInterpolate,PALShowTrigger, 0, Current + j);
      area[r] = iCustom(NULL, 0, "PalND_v1.55",AreaTimeFrame,AreaShowValue,AreaType,AreaemaPeriod,AreaAreaBars,AreaSmoothLength,AreaSmoothPhase,AreaSmoothDouble,AreaInterpolate,AreaShowTrigger, 0, Current + j);
   }
   
   //+------------------------------------------------------------------+
   //| Variable End                                                     |
   //+------------------------------------------------------------------+

   //Check position
   bool IsTrade = False;
   bool BuyActive =False;
   bool SellActive = False;

   for (int i = 0; i < Total; i ++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderType() == OP_BUY) BuyActive = True;
      if (OrderType() == OP_SELL) SellActive = True;
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {
         IsTrade = True;
         if(OrderType() == OP_BUY) {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Buy)                                           |
            //+------------------------------------------------------------------+



            //+------------------------------------------------------------------+
            //| Signal End(Exit Buy)                                             |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if(Bid - OrderOpenPrice() > Point * TrailingStop) {
                  if(OrderStopLoss() < Bid - Point * TrailingStop) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         } else {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Sell)                                          |
            //+------------------------------------------------------------------+

            

            //+------------------------------------------------------------------+
            //| Signal End(Exit Sell)                                            |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if((OrderOpenPrice() - Ask) > (Point * TrailingStop)) {
                  if((OrderStopLoss() > (Ask + Point * TrailingStop)) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         }
      }
   }

   //+------------------------------------------------------------------+
   //| Signal Begin(Entry)                                              |
   //+------------------------------------------------------------------+

   int BullPALUps=0, BullPALDns=0;
   int BullAreaUps=0, BullAreaDns=0;
   for (r=0; r<=BullUpCount-1; r++)
   {
      if (pal[r] >= pal[BullUpCount-1]) BullPALUps++;
      if (area[r] >= area[BullUpCount-1]) BullAreaUps++;
   }
   for (r=0; r<=BullDnCount-1; r++)
   {
      if (pal[r] <= pal[BullDnCount-1]) BullPALDns++;
      if (area[r] <= area[BullDnCount-1]) BullAreaDns++;
   }

   if (
      (BullPALUps == BullUpCount) &&
      (BullAreaUps == BullUpCount) &&
      (BullPALDns == BullDnCount) &&
      (BullAreaDns == BullDnCount) &&
      (0 != 1)
   )
   {
      Order = SIGNAL_BUY;
   }

   int BearPALUps=0, BearPALDns=0;
   int BearAreaUps=0, BearAreaDns=0;
   for (r=0; r<=BearUpCount-1; r++)
   {
      if (pal[r] >= pal[BearUpCount-1]) BearPALUps++;
      if (area[r] >= area[BearUpCount-1]) BearAreaUps++;
   }
   for (r=0; r<=BearDnCount-1; r++)
   {
      if (pal[r] <= pal[BearDnCount-1]) BearPALDns++;
      if (area[r] <= area[BearDnCount-1]) BearAreaDns++;
   }

   if (
      (BearPALUps == BearUpCount) &&
      (BearAreaUps == BearUpCount) &&
      (BearPALDns == BearDnCount) &&
      (BearAreaDns == BearDnCount) &&
      (0 != 1)
   )
   {
      Order = SIGNAL_SELL;
   }

   lastTime =  Time[0];

   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+
   string TradeComment = DoubleToStr(pal[0],4) + "_" + DoubleToStr(area[0],4);

   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (UseStopLoss) StopLossLevel = Ask - StopLoss * Point; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, StopLossLevel, TakeProfitLevel, "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
         if(Ticket > 0) {
            BuyActive = True;
            TradeCount++;
            if(CreateScreenshots) CreateScreenshot();
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("BUY order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
			} else {
				Print("Error opening BUY order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (UseStopLoss) StopLossLevel = Bid + StopLoss * Point; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Bid - TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, StopLossLevel, TakeProfitLevel, "Sell(#" + MagicNumber + ")", MagicNumber, 0, Yellow);
         if(Ticket > 0) {
            SellActive = True;
            TradeCount++;
            if(CreateScreenshots) CreateScreenshot();
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("SELL order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
			} else {
				Print("Error opening SELL order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   if (!EachTickMode) BarCount = Bars;
   if (IsTrade && !WasTrade) WasTrade=true;
   if (WasTrade && !IsTrade)
      {
      WasTrade = false;
      if(CreateScreenshots) CreateScreenshot();
      }      
   if (!EachTickMode) BarCount = Bars;
   subWriteToChart();


   return(0);
}
//+------------------------------------------------------------------+

void subWriteToChart()
{

   
   string sComment   = "";
   string sp         = "----------------------------------------\n";
   string NL         = "\n";

   sComment = sp;
   sComment = sComment + WindowExpertName()+ "  Balance=" + DoubleToStr(AccountBalance(),0)+ "  Equity=" + DoubleToStr(AccountEquity(),0) + NL;
   sComment = sComment + "Current Server DateTime = " + TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS) + NL;
   sComment = sComment + "TimeCount = " + (Bars-TimeCount) + "   TradeCount = " + TradeCount + NL;
   sComment = sComment + "BuyActive = " + BuyActive + "   SellActive = " + SellActive + NL;
   sComment = sComment + NL;
   sComment = sComment + "BullUpCount = " + BullUpCount + "    BullDnCount = " + BullDnCount + NL;
   sComment = sComment + "BearUpCount = " + BearUpCount + "    BearDnCount = " + BearDnCount + NL;
   sComment = sComment + NL;
   sComment = sComment + "        pal[0] = " + DoubleToStr(pal[0],4) + NL;
   sComment = sComment + "       area[0] = " + DoubleToStr(area[0],4) + NL;
   sComment = sComment + sp;
  
   Comment(sComment);
}

bool CreateScreenshot()
  {
   RefreshRates();
   subWriteToChart();
   datetime cur_time = TimeCurrent();
   string file_name = StringConcatenate(path_screenshots,"Screenshot_",IntegerToStr(TimeYear(cur_time),4),"_",IntegerToStr(TimeMonth(cur_time),2),"_",IntegerToStr(TimeDay(cur_time),2)," ",IntegerToStr(TimeHour(cur_time),2),"_",IntegerToStr(TimeMinute(cur_time),2),"_",IntegerToStr(TimeSeconds(cur_time),2),".gif");
   bool error = WindowScreenShot(file_name,ScreenshotSizeX,ScreenshotSizeY,ScreenshotStartBar,ScreenshotChartScale,ScreenshotChartMode);
   return(error);
  }

string IntegerToStr(int integer_number, int minimum_chars, string add_char = "0")
  {
   string result = DoubleToStr(integer_number,0);
   for(int i=minimum_chars-StringLen(result); i>0; i--) result = StringConcatenate(add_char,result);
   return(result);
  }


